#include <iostream> 
#include <vector> 
#include <string> 
#include <fstream> 
#include <sstream>
#include <cassert> 
using namespace std;

vector<int> leer();
void imprimir(vector<int>);
float mediana(vector<int>);
vector<int> quicksort(vector<int>,int *);

vector<int> leer()
{
    string linea;
    vector<int> ret_val;
    int temp;
    ifstream archivo("QuickSort.txt");
    if(archivo.is_open())
    {
        while(archivo.good())
        {
            if(getline(archivo,linea)){
                istringstream ss(linea,stringstream::in | stringstream::out);
                ss >> temp;
                ret_val.push_back(temp);
            }
            else
                break;
        }
        archivo.close();
    }
    else
        throw 1;
    //imprimir(ret_val);
    cout<<"Exito\n";
    return ret_val;
}
void imprimir(vector<int> lista)
{
    for(unsigned int val=0;val<lista.size();val++)
        cout<<lista[val]<<"\n";
}

vector<int> quicksort(vector<int> lista, int *contador)
{
    if (lista.empty())
        return lista;
    else
    {
        vector<int> menores,mayores;
        int pivot = mediana(lista);
        //int pivot = lista[0];
        for(unsigned int valor = 0;valor<lista.size();valor++)
        {
            if(lista[valor]<pivot)
                menores.push_back(lista[valor]);
            else
                mayores.push_back(lista[valor]);
        }
        assert(!(mayores.size()<lista.size()||menores.size()<lista.size()));
        menores = quicksort(menores,contador);
        mayores = quicksort(mayores,contador);
        menores.push_back(pivot);
        menores.insert(menores.end(),mayores.begin(),mayores.end());
        return menores;
    }
}
float mediana(vector<int> lista)
{
    cout<<"Mediana\n";
    int tam = lista.size();
    assert(tam>0);
    if (tam >=3)
    {
        vector<int> aux;
        aux.push_back(lista[0]);
        aux.push_back(lista[tam-1]);
        aux.push_back(lista[int(tam/2)]);
        aux = quicksort(aux,NULL);
        if (tam%2==0)
        {
            return float(aux[int(tam/2) - 1]);
        }
        else
            return float(aux[int(tam/2)]);
    }
    else if(tam == 2)
    {
        return (lista[1]+lista[0])/2.0;
    }
    else
        return float(lista[0]);
}


int main()
{
    vector<int> valor = leer();
    cout<<"Main\n";
    vector<int> ordenado = quicksort(valor,NULL);
    return 0;
}
